# Puzle Gardener

## About

With Gardener, bootstraping a project has never been so easy !

The project is currently in WIP.

## Roadmap

- Jardiner Data management
    - ~~Define the data file structure~~
    - ~~Find and load the file if it exists~~
    - ~~Otherwise, prompt the user~~
        - ~~The prompt take in account the required values for a gardener config file~~
        - ~~The prompt take in account the required values for the seed config file~~
- CLI
    - Config file location
    - verbose option
- Seed
    - ~~Find a seed (to begin, in local only)~~
    - ~~Seed Data requirement (config file &| user prompt)~~
    - ~~Copy and compile seed files with Jardiner & Seed data~~
    - ~~The files and folders can have template values in their name~~
    - Find a seed defined in a hub
- Git Management
    - ~~Init the project~~
    - ~~First git commit~~
    - Initialize a git flow ?

## Development

To make easier the edition of the source code, we use a makefile.
You can find here the following commands.

### Download the dependencies

```sh
    $ make init
```

### Clean

Clean the artifacts generated by the local use of Gardener

```sh
    $ make clean
```

### Linter (use of PyLint)


```sh
    $ make lint
```

### Save the project dependencies in requirements file


```sh
    $ make freeze
```
freeze:
	rm src/requirements.txt
	pipreqs -r > src/requirements.txt

### Install step

```sh
    $ make install
```

## Use

### Install

To install the package with pip, just type:

```sh
    $ pip install gardener
```

### Add a Seed

Before to begin, you have te create somd Seeds.

#### The seed content

A Seed is a folder with content (files and subfolder) which will be used to generate another folder.
A seed has at its root a file called `puzle-seed.yml`.
This file describes the current seed :

The required attrib is the seed name. You can define some fields that will be used to generate the content.
These fields will be fetched among a data fetching pipeline (config files -> prompt).
Each field has a label, a text used during the prompt step and if it required or not (if it is, it will be asked during
the prompt step, if the user has not give it in the config file).

Here you have an exemple of a `puzle-seed.yml` file:

```yml
name: sample
fields:
  author:
    required: true
    default: ""
    text: "The project author:"
  version:
    required: true
    default: "0.0.1"
    text: "The project version:"
  roadmap:
    required: false
    default: []
    text: "The Roadmap items"
```

You can use these data to inject it during the compilation step.
Each file having the suffix `.mustache` will be compiled using the **mustache** syntax.
So, you can add some logical insertions in your code such as:

```markdown
<!-- Readme.md.mustache -->
## Roadmap

{{#seed.fields.roadmap}}
    - {{.}}
{{/seed.fields.roadmap}}
```

There are two types of injected data.
The first one is the project meta-data, defined by the `gardener` prefix.

- project_name
- seed_name
- seed_location
- destination

The second one is the seed data, given by the user, defined by the `seed`.
Here, you can use all the data of the seed (varying according to the seed).


#### Copy the seed into the Global folder

To copy a folder to the Gardener Global folder:

```sh
    Usage: gardener add [OPTIONS] [TO_COPY]
```

Options:

  -g, --gardener_rc PATH  Location of the global Gardener Folder
  -f, --force             Override the seed folder if it exists yet
  --help                  Show this message and exit.


### Use

Then, you can generate a project with the following command:

```sh
    gardener generate [OPTIONS] SEED_NAME
```

Options:

  -c, --config PATH         Location of the config file
  -l, --seed_location PATH  Location of the Seeds
  -n, --project_name TEXT   The project name, used for the generation
  -d, --destination PATH    The destination of the generation process
  --help                    Show this message and exit.


